import{S as ki,i as Ei,s as Fi,e as r,k as c,w as T,t as n,M as zi,c as s,d as t,m,a,x as b,h as i,b as d,N as Ci,G as e,g as f,y as x,q as w,o as P,B as $,v as Ai,L as $r}from"../../chunks/vendor-hf-doc-builder.js";import{T as mn}from"../../chunks/Tip-hf-doc-builder.js";import{D as M}from"../../chunks/Docstring-hf-doc-builder.js";import{C as yr}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as ne}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as Pr}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function Li(k){let h,y,_,u,v;return u=new yr({props:{code:`from transformers import TvltConfig, TvltModel

# # Initializing a TVLT ZinengTang/tvlt-base style configuration
configuration = TvltConfig()

# # Initializing a model (with random weights) from the ZinengTang/tvlt-base style configuration
model = TvltModel(configuration)

# Accessing the model configuration
configuration = model.config`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> TvltConfig, TvltModel

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># # Initializing a TVLT ZinengTang/tvlt-base style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = TvltConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># # Initializing a model (with random weights) from the ZinengTang/tvlt-base style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TvltModel(configuration)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Accessing the model configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = model.config`}}),{c(){h=r("p"),y=n("Example:"),_=c(),T(u.$$.fragment)},l(l){h=s(l,"P",{});var g=a(h);y=i(g,"Example:"),g.forEach(t),_=m(l),b(u.$$.fragment,l)},m(l,g){f(l,h,g),e(h,y),f(l,_,g),x(u,l,g),v=!0},p:$r,i(l){v||(w(u.$$.fragment,l),v=!0)},o(l){P(u.$$.fragment,l),v=!1},d(l){l&&t(h),l&&t(_),$(u,l)}}}function Ii(k){let h,y,_,u,v;return{c(){h=r("p"),y=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),_=r("code"),u=n("Module"),v=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){h=s(l,"P",{});var g=a(h);y=i(g,"Although the recipe for forward pass needs to be defined within this function, one should call the "),_=s(g,"CODE",{});var E=a(_);u=i(E,"Module"),E.forEach(t),v=i(g,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),g.forEach(t)},m(l,g){f(l,h,g),e(h,y),e(h,_),e(_,u),e(h,v)},d(l){l&&t(h)}}}function Mi(k){let h,y,_,u,v;return u=new yr({props:{code:`from transformers import TvltProcessor, TvltModel
import numpy as np
import torch

num_frames = 8
images = list(np.random.randn(num_frames, 3, 224, 224))
audio = list(np.random.randn(10000))

processor = TvltProcessor.from_pretrained("ZinengTang/tvlt-base")
model = TvltModel.from_pretrained("ZinengTang/tvlt-base")

input_dict = processor(images, audio, sampling_rate=44100, return_tensors="pt")

outputs = model(**input_dict)
loss = outputs.loss`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> TvltProcessor, TvltModel
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>num_frames = <span class="hljs-number">8</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>images = <span class="hljs-built_in">list</span>(np.random.randn(num_frames, <span class="hljs-number">3</span>, <span class="hljs-number">224</span>, <span class="hljs-number">224</span>))
<span class="hljs-meta">&gt;&gt;&gt; </span>audio = <span class="hljs-built_in">list</span>(np.random.randn(<span class="hljs-number">10000</span>))

<span class="hljs-meta">&gt;&gt;&gt; </span>processor = TvltProcessor.from_pretrained(<span class="hljs-string">&quot;ZinengTang/tvlt-base&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TvltModel.from_pretrained(<span class="hljs-string">&quot;ZinengTang/tvlt-base&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>input_dict = processor(images, audio, sampling_rate=<span class="hljs-number">44100</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**input_dict)
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = outputs.loss`}}),{c(){h=r("p"),y=n("Examples:"),_=c(),T(u.$$.fragment)},l(l){h=s(l,"P",{});var g=a(h);y=i(g,"Examples:"),g.forEach(t),_=m(l),b(u.$$.fragment,l)},m(l,g){f(l,h,g),e(h,y),f(l,_,g),x(u,l,g),v=!0},p:$r,i(l){v||(w(u.$$.fragment,l),v=!0)},o(l){P(u.$$.fragment,l),v=!1},d(l){l&&t(h),l&&t(_),$(u,l)}}}function ji(k){let h,y,_,u,v;return{c(){h=r("p"),y=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),_=r("code"),u=n("Module"),v=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){h=s(l,"P",{});var g=a(h);y=i(g,"Although the recipe for forward pass needs to be defined within this function, one should call the "),_=s(g,"CODE",{});var E=a(_);u=i(E,"Module"),E.forEach(t),v=i(g,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),g.forEach(t)},m(l,g){f(l,h,g),e(h,y),e(h,_),e(_,u),e(h,v)},d(l){l&&t(h)}}}function Vi(k){let h,y,_,u,v;return u=new yr({props:{code:`from transformers import TvltProcessor, TvltForPreTraining
import numpy as np
import torch

num_frames = 8
images = list(np.random.randn(num_frames, 3, 224, 224))
images_mixed = list(np.random.randn(num_frames, 3, 224, 224))
audio = list(np.random.randn(10000))
processor = TvltProcessor.from_pretrained("ZinengTang/tvlt-base")
model = TvltForPreTraining.from_pretrained("ZinengTang/tvlt-base")
input_dict = processor(
    images, audio, images_mixed, sampling_rate=44100, mask_pixel=True, mask_audio=True, return_tensors="pt"
)

outputs = model(**input_dict)
loss = outputs.loss`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> TvltProcessor, TvltForPreTraining
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>num_frames = <span class="hljs-number">8</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>images = <span class="hljs-built_in">list</span>(np.random.randn(num_frames, <span class="hljs-number">3</span>, <span class="hljs-number">224</span>, <span class="hljs-number">224</span>))
<span class="hljs-meta">&gt;&gt;&gt; </span>images_mixed = <span class="hljs-built_in">list</span>(np.random.randn(num_frames, <span class="hljs-number">3</span>, <span class="hljs-number">224</span>, <span class="hljs-number">224</span>))
<span class="hljs-meta">&gt;&gt;&gt; </span>audio = <span class="hljs-built_in">list</span>(np.random.randn(<span class="hljs-number">10000</span>))
<span class="hljs-meta">&gt;&gt;&gt; </span>processor = TvltProcessor.from_pretrained(<span class="hljs-string">&quot;ZinengTang/tvlt-base&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TvltForPreTraining.from_pretrained(<span class="hljs-string">&quot;ZinengTang/tvlt-base&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>input_dict = processor(
<span class="hljs-meta">... </span>    images, audio, images_mixed, sampling_rate=<span class="hljs-number">44100</span>, mask_pixel=<span class="hljs-literal">True</span>, mask_audio=<span class="hljs-literal">True</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**input_dict)
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = outputs.loss`}}),{c(){h=r("p"),y=n("Examples:"),_=c(),T(u.$$.fragment)},l(l){h=s(l,"P",{});var g=a(h);y=i(g,"Examples:"),g.forEach(t),_=m(l),b(u.$$.fragment,l)},m(l,g){f(l,h,g),e(h,y),f(l,_,g),x(u,l,g),v=!0},p:$r,i(l){v||(w(u.$$.fragment,l),v=!0)},o(l){P(u.$$.fragment,l),v=!1},d(l){l&&t(h),l&&t(_),$(u,l)}}}function qi(k){let h,y,_,u,v;return{c(){h=r("p"),y=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),_=r("code"),u=n("Module"),v=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){h=s(l,"P",{});var g=a(h);y=i(g,"Although the recipe for forward pass needs to be defined within this function, one should call the "),_=s(g,"CODE",{});var E=a(_);u=i(E,"Module"),E.forEach(t),v=i(g,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),g.forEach(t)},m(l,g){f(l,h,g),e(h,y),e(h,_),e(_,u),e(h,v)},d(l){l&&t(h)}}}function Si(k){let h,y,_,u,v;return u=new yr({props:{code:`from transformers import TvltProcessor, TvltForAudioVisualClassification
import numpy as np
import torch

num_frames = 8
images = list(np.random.randn(num_frames, 3, 224, 224))
audio = list(np.random.randn(10000))
processor = TvltProcessor.from_pretrained("ZinengTang/tvlt-base")
model = TvltForAudioVisualClassification.from_pretrained("ZinengTang/tvlt-base")
input_dict = processor(images, audio, sampling_rate=44100, return_tensors="pt")

outputs = model(**input_dict)
loss = outputs.loss`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> TvltProcessor, TvltForAudioVisualClassification
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>num_frames = <span class="hljs-number">8</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>images = <span class="hljs-built_in">list</span>(np.random.randn(num_frames, <span class="hljs-number">3</span>, <span class="hljs-number">224</span>, <span class="hljs-number">224</span>))
<span class="hljs-meta">&gt;&gt;&gt; </span>audio = <span class="hljs-built_in">list</span>(np.random.randn(<span class="hljs-number">10000</span>))
<span class="hljs-meta">&gt;&gt;&gt; </span>processor = TvltProcessor.from_pretrained(<span class="hljs-string">&quot;ZinengTang/tvlt-base&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TvltForAudioVisualClassification.from_pretrained(<span class="hljs-string">&quot;ZinengTang/tvlt-base&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>input_dict = processor(images, audio, sampling_rate=<span class="hljs-number">44100</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**input_dict)
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = outputs.loss`}}),{c(){h=r("p"),y=n("Examples:"),_=c(),T(u.$$.fragment)},l(l){h=s(l,"P",{});var g=a(h);y=i(g,"Examples:"),g.forEach(t),_=m(l),b(u.$$.fragment,l)},m(l,g){f(l,h,g),e(h,y),f(l,_,g),x(u,l,g),v=!0},p:$r,i(l){v||(w(u.$$.fragment,l),v=!0)},o(l){P(u.$$.fragment,l),v=!1},d(l){l&&t(h),l&&t(_),$(u,l)}}}function Ni(k){let h,y,_,u,v,l,g,E,kr,Vt,Z,ie,Jo,qe,Er,Yo,Fr,qt,le,zr,Se,Cr,Ar,St,Po,Lr,Nt,$o,Xo,Ir,Dt,yo,Mr,Ot,j,D,jr,Ko,Vr,qr,Qo,Sr,Nr,ko,Dr,Or,Rr,H,Wr,et,Ur,Zr,ot,Hr,Br,Gr,Ne,Jr,Eo,Yr,Xr,Kr,tt,Qr,Rt,De,Oe,pn,Wt,de,es,Fo,os,ts,Ut,W,rs,Re,ss,as,We,ns,is,Zt,B,ce,rt,Ue,ls,st,ds,Ht,F,Ze,cs,G,ms,zo,ps,hs,He,fs,us,gs,J,_s,Co,vs,Ts,Ao,bs,xs,ws,me,Bt,Y,pe,at,Be,Ps,nt,$s,Gt,z,Ge,ys,it,ks,Es,V,Lo,Fs,zs,Io,Cs,As,Mo,Ls,Is,Je,lt,Ms,js,Vs,qs,he,Ye,Ss,C,Ns,dt,Ds,Os,jo,Rs,Ws,ct,Us,Zs,Xe,mt,Hs,Bs,Gs,Jt,X,fe,pt,Ke,Js,ht,Ys,Yt,A,Qe,Xs,ft,Ks,Qs,ut,ea,oa,ue,eo,ta,gt,ra,Xt,K,ge,_t,oo,sa,vt,aa,Kt,L,to,na,Tt,ia,la,ro,da,Vo,ca,ma,pa,_e,so,ha,bt,fa,Qt,Q,ve,xt,ao,ua,wt,ga,er,O,no,_a,io,va,lo,Ta,ba,xa,q,co,wa,ee,Pa,qo,$a,ya,Pt,ka,Ea,Fa,Te,za,be,or,oe,xe,$t,mo,Ca,yt,Aa,tr,R,po,La,ho,Ia,fo,Ma,ja,Va,S,uo,qa,te,Sa,So,Na,Da,kt,Oa,Ra,Wa,we,Ua,Pe,rr,re,$e,Et,go,Za,Ft,Ha,sr,I,_o,Ba,zt,Ga,Ja,vo,Ya,To,Xa,Ka,Qa,N,bo,en,se,on,No,tn,rn,Ct,sn,an,nn,ye,ln,ke,ar;return l=new ne({}),qe=new ne({}),Ue=new ne({}),Ze=new M({props:{name:"class transformers.TvltConfig",anchor:"transformers.TvltConfig",parameters:[{name:"image_size",val:" = 224"},{name:"spectrogram_length",val:" = 2048"},{name:"frequency_length",val:" = 128"},{name:"image_patch_size",val:" = [16, 16]"},{name:"audio_patch_size",val:" = [16, 16]"},{name:"num_image_channels",val:" = 3"},{name:"num_audio_channels",val:" = 1"},{name:"num_frames",val:" = 8"},{name:"hidden_size",val:" = 768"},{name:"num_hidden_layers",val:" = 12"},{name:"num_attention_heads",val:" = 12"},{name:"intermediate_size",val:" = 3072"},{name:"hidden_act",val:" = 'gelu'"},{name:"hidden_dropout_prob",val:" = 0.0"},{name:"attention_probs_dropout_prob",val:" = 0.0"},{name:"initializer_range",val:" = 0.02"},{name:"layer_norm_eps",val:" = 1e-06"},{name:"qkv_bias",val:" = True"},{name:"use_mean_pooling",val:" = False"},{name:"decoder_num_attention_heads",val:" = 16"},{name:"decoder_hidden_size",val:" = 512"},{name:"decoder_num_hidden_layers",val:" = 8"},{name:"decoder_intermediate_size",val:" = 2048"},{name:"pixel_mask_ratio",val:" = 0.75"},{name:"audio_mask_ratio",val:" = 0.15"},{name:"audio_mask_type",val:" = 'frame-level'"},{name:"task_matching",val:" = True"},{name:"task_mae",val:" = True"},{name:"loss_type",val:" = 'classification'"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TvltConfig.image_size",description:`<strong>image_size</strong> (<code>int</code>, <em>optional</em>, defaults to 224) &#x2014;
The size (resolution) of each image.`,name:"image_size"},{anchor:"transformers.TvltConfig.spectrogram_length",description:`<strong>spectrogram_length</strong> (<code>int</code>, <em>optional</em>, defaults to 2048) &#x2014;
The time length of each audio spectrogram.`,name:"spectrogram_length"},{anchor:"transformers.TvltConfig.frequency_length",description:`<strong>frequency_length</strong> (<code>int</code>, <em>optional</em>, defaults to 128) &#x2014;
The frequency length of audio spectrogram.`,name:"frequency_length"},{anchor:"transformers.TvltConfig.image_patch_size",description:`<strong>image_patch_size</strong> (<code>List[int]</code>, <em>optional</em>, defaults to <code>[16, 16]</code>) &#x2014;
The size (resolution) of each image patch.`,name:"image_patch_size"},{anchor:"transformers.TvltConfig.audio_patch_size",description:`<strong>audio_patch_size</strong> (<code>List[int]</code>, <em>optional</em>, defaults to <code>[16, 16]</code>) &#x2014;
The size (resolution) of each audio patch.`,name:"audio_patch_size"},{anchor:"transformers.TvltConfig.num_image_channels",description:`<strong>num_image_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 3) &#x2014;
The number of input image channels.`,name:"num_image_channels"},{anchor:"transformers.TvltConfig.num_audio_channels",description:`<strong>num_audio_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of input audio channels.`,name:"num_audio_channels"},{anchor:"transformers.TvltConfig.num_frames",description:`<strong>num_frames</strong> (<code>int</code>, <em>optional</em>, defaults to 8) &#x2014;
The maximum number of frames for an input video.`,name:"num_frames"},{anchor:"transformers.TvltConfig.hidden_size",description:`<strong>hidden_size</strong> (<code>int</code>, <em>optional</em>, defaults to 768) &#x2014;
Dimensionality of the encoder layers and the pooler layer.`,name:"hidden_size"},{anchor:"transformers.TvltConfig.num_hidden_layers",description:`<strong>num_hidden_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 12) &#x2014;
Number of hidden layers in the Transformer encoder.`,name:"num_hidden_layers"},{anchor:"transformers.TvltConfig.num_attention_heads",description:`<strong>num_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 12) &#x2014;
Number of attention heads for each attention layer in the Transformer encoder.`,name:"num_attention_heads"},{anchor:"transformers.TvltConfig.intermediate_size",description:`<strong>intermediate_size</strong> (<code>int</code>, <em>optional</em>, defaults to 3072) &#x2014;
Dimensionality of the &#x201C;intermediate&#x201D; (i.e., feed-forward) layer in the Transformer encoder.`,name:"intermediate_size"},{anchor:"transformers.TvltConfig.hidden_act",description:`<strong>hidden_act</strong> (<code>str</code> or <code>function</code>, <em>optional</em>, defaults to <code>&quot;gelu&quot;</code>) &#x2014;
The non-linear activation function (function or string) in the encoder and pooler. If string, <code>&quot;gelu&quot;</code>,
<code>&quot;relu&quot;</code>, <code>&quot;selu&quot;</code> and <code>&quot;gelu_new&quot;</code> are supported.`,name:"hidden_act"},{anchor:"transformers.TvltConfig.hidden_dropout_prob",description:`<strong>hidden_dropout_prob</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout probabilitiy for all fully connected layers in the embeddings, encoder, and pooler.`,name:"hidden_dropout_prob"},{anchor:"transformers.TvltConfig.attention_probs_dropout_prob",description:`<strong>attention_probs_dropout_prob</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout ratio for the attention probabilities.`,name:"attention_probs_dropout_prob"},{anchor:"transformers.TvltConfig.initializer_range",description:`<strong>initializer_range</strong> (<code>float</code>, <em>optional</em>, defaults to 0.02) &#x2014;
The standard deviation of the truncated_normal_initializer for initializing all weight matrices.`,name:"initializer_range"},{anchor:"transformers.TvltConfig.layer_norm_eps",description:`<strong>layer_norm_eps</strong> (<code>float</code>, <em>optional</em>, defaults to 1e-6) &#x2014;
The epsilon used by the layer normalization layers.`,name:"layer_norm_eps"},{anchor:"transformers.TvltConfig.qkv_bias",description:`<strong>qkv_bias</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to add a bias to the queries, keys and values.`,name:"qkv_bias"},{anchor:"transformers.TvltConfig.use_mean_pooling",description:`<strong>use_mean_pooling</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to mean pool the final hidden states instead of using the final hidden state of the [CLS] token.`,name:"use_mean_pooling"},{anchor:"transformers.TvltConfig.decoder_num_attention_heads",description:`<strong>decoder_num_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 16) &#x2014;
Number of attention heads for each attention layer in the decoder.`,name:"decoder_num_attention_heads"},{anchor:"transformers.TvltConfig.decoder_hidden_size",description:`<strong>decoder_hidden_size</strong> (<code>int</code>, <em>optional</em>, defaults to 512) &#x2014;
Dimensionality of the decoder.`,name:"decoder_hidden_size"},{anchor:"transformers.TvltConfig.decoder_num_hidden_layers",description:`<strong>decoder_num_hidden_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 8) &#x2014;
Number of hidden layers in the decoder.`,name:"decoder_num_hidden_layers"},{anchor:"transformers.TvltConfig.decoder_intermediate_size",description:`<strong>decoder_intermediate_size</strong> (<code>int</code>, <em>optional</em>, defaults to 2048) &#x2014;
Dimensionality of the &#x201C;intermediate&#x201D; (i.e., feed-forward) layer in the decoder.`,name:"decoder_intermediate_size"},{anchor:"transformers.TvltConfig.pixel_mask_ratio",description:`<strong>pixel_mask_ratio</strong> (<code>float</code>, <em>optional</em>, defaults to 0.75) &#x2014;
Image patch masking ratio.`,name:"pixel_mask_ratio"},{anchor:"transformers.TvltConfig.audio_mask_ratio",description:`<strong>audio_mask_ratio</strong> (<code>float</code>, <em>optional</em>, defaults to 0.15) &#x2014;
Audio patch masking ratio.`,name:"audio_mask_ratio"},{anchor:"transformers.TvltConfig.audio_mask_type",description:`<strong>audio_mask_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;frame-level&quot;</code>) &#x2014;
Audio patch masking type, choose between &#x201C;frame-level&#x201D; and &#x201C;patch-level&#x201D;.`,name:"audio_mask_type"},{anchor:"transformers.TvltConfig.task_matching",description:`<strong>task_matching</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to use vision audio matching task in pretraining.`,name:"task_matching"},{anchor:"transformers.TvltConfig.task_mae",description:`<strong>task_mae</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to use the masked auto-encoder (MAE) in pretraining.`,name:"task_mae"},{anchor:"transformers.TvltConfig.loss_type",description:`<strong>loss_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;classification&quot;</code>) &#x2014;
Loss types including regression and classification.`,name:"loss_type"}],source:"https://github.com/huggingface/transformers/blob/vr_22367/src/transformers/models/tvlt/configuration_tvlt.py#L28"}}),me=new Pr({props:{anchor:"transformers.TvltConfig.example",$$slots:{default:[Li]},$$scope:{ctx:k}}}),Be=new ne({}),Ge=new M({props:{name:"class transformers.TvltProcessor",anchor:"transformers.TvltProcessor",parameters:[{name:"image_processor",val:""},{name:"feature_extractor",val:""}],parametersDescription:[{anchor:"transformers.TvltProcessor.image_processor",description:`<strong>image_processor</strong> (<code>TvltImageProcessor</code>) &#x2014;
An instance of <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltImageProcessor">TvltImageProcessor</a>. The image processor is a required input.`,name:"image_processor"},{anchor:"transformers.TvltProcessor.feature_extractor",description:`<strong>feature_extractor</strong> (<code>TvltFeatureExtractor</code>) &#x2014;
An instance of <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltFeatureExtractor">TvltFeatureExtractor</a>. The feature extractor is a required input.`,name:"feature_extractor"}],source:"https://github.com/huggingface/transformers/blob/vr_22367/src/transformers/models/tvlt/processing_tvlt.py#L22"}}),Ye=new M({props:{name:"__call__",anchor:"transformers.TvltProcessor.__call__",parameters:[{name:"images",val:" = None"},{name:"audio",val:" = None"},{name:"images_mixed",val:" = None"},{name:"sampling_rate",val:" = None"},{name:"mask_audio",val:" = False"},{name:"mask_pixel",val:" = False"},{name:"*args",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/vr_22367/src/transformers/models/tvlt/processing_tvlt.py#L45"}}),Ke=new ne({}),Qe=new M({props:{name:"class transformers.TvltImageProcessor",anchor:"transformers.TvltImageProcessor",parameters:[{name:"do_resize",val:": bool = True"},{name:"size",val:": typing.Dict[str, int] = None"},{name:"patch_size",val:": typing.List[int] = [16, 16]"},{name:"num_frames",val:": int = 8"},{name:"resample",val:": Resampling = <Resampling.BILINEAR: 2>"},{name:"do_center_crop",val:": bool = True"},{name:"crop_size",val:": typing.Dict[str, int] = None"},{name:"do_rescale",val:": bool = True"},{name:"rescale_factor",val:": typing.Union[int, float] = 0.00392156862745098"},{name:"do_normalize",val:": bool = True"},{name:"image_mean",val:": typing.Union[float, typing.List[float], NoneType] = [0.5, 0.5, 0.5]"},{name:"image_std",val:": typing.Union[float, typing.List[float], NoneType] = [0.5, 0.5, 0.5]"},{name:"init_mask_generator",val:" = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TvltImageProcessor.do_resize",description:`<strong>do_resize</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to resize the image&#x2019;s (height, width) dimensions to the specified <code>size</code>. Can be overridden by the
<code>do_resize</code> parameter in the <code>preprocess</code> method.`,name:"do_resize"},{anchor:"transformers.TvltImageProcessor.size",description:`<strong>size</strong> (<code>Dict[str, int]</code> <em>optional</em>, defaults to <code>{&quot;shortest_edge&quot; -- 224}</code>):
Size of the output image after resizing. The shortest edge of the image will be resized to
<code>size[&quot;shortest_edge&quot;]</code> while maintaining the aspect ratio of the original image. Can be overriden by
<code>size</code> in the <code>preprocess</code> method.`,name:"size"},{anchor:"transformers.TvltImageProcessor.patch_size",description:`<strong>patch_size</strong> (<code>List[int]</code> <em>optional</em>, defaults to [16,16]) &#x2014;
The patch size of image patch embedding.`,name:"patch_size"},{anchor:"transformers.TvltImageProcessor.num_frames",description:`<strong>num_frames</strong> (<code>int</code> <em>optional</em>, defaults to 8) &#x2014;
The maximum number of video frames.`,name:"num_frames"},{anchor:"transformers.TvltImageProcessor.resample",description:`<strong>resample</strong> (<code>PILImageResampling</code>, <em>optional</em>, defaults to <code>PILImageResampling.BILINEAR</code>) &#x2014;
Resampling filter to use if resizing the image. Can be overridden by the <code>resample</code> parameter in the
<code>preprocess</code> method.`,name:"resample"},{anchor:"transformers.TvltImageProcessor.do_center_crop",description:`<strong>do_center_crop</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to center crop the image to the specified <code>crop_size</code>. Can be overridden by the <code>do_center_crop</code>
parameter in the <code>preprocess</code> method.`,name:"do_center_crop"},{anchor:"transformers.TvltImageProcessor.crop_size",description:`<strong>crop_size</strong> (<code>Dict[str, int]</code>, <em>optional</em>, defaults to <code>{&quot;height&quot; -- 224, &quot;width&quot;: 224}</code>):
Size of the image after applying the center crop. Can be overridden by the <code>crop_size</code> parameter in the
<code>preprocess</code> method.`,name:"crop_size"},{anchor:"transformers.TvltImageProcessor.do_rescale",description:`<strong>do_rescale</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to rescale the image by the specified scale <code>rescale_factor</code>. Can be overridden by the <code>do_rescale</code>
parameter in the <code>preprocess</code> method.`,name:"do_rescale"},{anchor:"transformers.TvltImageProcessor.rescale_factor",description:`<strong>rescale_factor</strong> (<code>int</code> or <code>float</code>, <em>optional</em>, defaults to 1/255) &#x2014;
Defines the scale factor to use if rescaling the image. Can be overridden by the <code>rescale_factor</code> parameter
in the <code>preprocess</code> method.`,name:"rescale_factor"},{anchor:"transformers.TvltImageProcessor.do_normalize",description:`<strong>do_normalize</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to normalize the image. Can be overridden by the <code>do_normalize</code> parameter in the <code>preprocess</code>
method.`,name:"do_normalize"},{anchor:"transformers.TvltImageProcessor.image_mean",description:`<strong>image_mean</strong> (<code>float</code> or <code>List[float]</code>, <em>optional</em>, defaults to <code>IMAGENET_STANDARD_MEAN</code>) &#x2014;
Mean to use if normalizing the image. This is a float or list of floats the length of the number of
channels in the image. Can be overridden by the <code>image_mean</code> parameter in the <code>preprocess</code> method.`,name:"image_mean"},{anchor:"transformers.TvltImageProcessor.image_std",description:`<strong>image_std</strong> (<code>float</code> or <code>List[float]</code>, <em>optional</em>, defaults to <code>IMAGENET_STANDARD_STD</code>) &#x2014;
Standard deviation to use if normalizing the image. This is a float or list of floats the length of the
number of channels in the image. Can be overridden by the <code>image_std</code> parameter in the <code>preprocess</code> method.`,name:"image_std"}],source:"https://github.com/huggingface/transformers/blob/vr_22367/src/transformers/models/tvlt/image_processing_tvlt.py#L68"}}),eo=new M({props:{name:"preprocess",anchor:"transformers.TvltImageProcessor.preprocess",parameters:[{name:"videos",val:": typing.Union[ForwardRef('PIL.Image.Image'), numpy.ndarray, ForwardRef('torch.Tensor'), typing.List[ForwardRef('PIL.Image.Image')], typing.List[numpy.ndarray], typing.List[ForwardRef('torch.Tensor')]]"},{name:"do_resize",val:": bool = None"},{name:"size",val:": typing.Dict[str, int] = None"},{name:"patch_size",val:": typing.List[int] = None"},{name:"num_frames",val:": int = None"},{name:"resample",val:": Resampling = None"},{name:"do_center_crop",val:": bool = None"},{name:"crop_size",val:": typing.Dict[str, int] = None"},{name:"do_rescale",val:": bool = None"},{name:"rescale_factor",val:": float = None"},{name:"do_normalize",val:": bool = None"},{name:"image_mean",val:": typing.Union[float, typing.List[float], NoneType] = None"},{name:"image_std",val:": typing.Union[float, typing.List[float], NoneType] = None"},{name:"is_mixed",val:": bool = False"},{name:"return_tensors",val:": typing.Union[str, transformers.utils.generic.TensorType, NoneType] = None"},{name:"data_format",val:": ChannelDimension = <ChannelDimension.FIRST: 'channels_first'>"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TvltImageProcessor.preprocess.videos",description:`<strong>videos</strong> (<code>ImageInput</code>) &#x2014;
Images or videos to preprocess.`,name:"videos"},{anchor:"transformers.TvltImageProcessor.preprocess.do_resize",description:`<strong>do_resize</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>self.do_resize</code>) &#x2014;
Whether to resize the image.`,name:"do_resize"},{anchor:"transformers.TvltImageProcessor.preprocess.size",description:`<strong>size</strong> (<code>Dict[str, int]</code>, <em>optional</em>, defaults to <code>self.size</code>) &#x2014;
Size of the image after applying resize.`,name:"size"},{anchor:"transformers.TvltImageProcessor.preprocess.patch_size",description:`<strong>patch_size</strong> (<code>List[int]</code> <em>optional</em>, defaults to self.patch_size) &#x2014;
The patch size of image patch embedding.`,name:"patch_size"},{anchor:"transformers.TvltImageProcessor.preprocess.num_frames",description:`<strong>num_frames</strong> (<code>int</code> <em>optional</em>, defaults to self.num_frames) &#x2014;
The maximum number of video frames.`,name:"num_frames"},{anchor:"transformers.TvltImageProcessor.preprocess.resample",description:`<strong>resample</strong> (<code>PILImageResampling</code>, <em>optional</em>, defaults to <code>self.resample</code>) &#x2014;
Resampling filter to use if resizing the image. This can be one of the enum <code>PILImageResampling</code>, Only
has an effect if <code>do_resize</code> is set to <code>True</code>.`,name:"resample"},{anchor:"transformers.TvltImageProcessor.preprocess.do_center_crop",description:`<strong>do_center_crop</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>self.do_centre_crop</code>) &#x2014;
Whether to centre crop the image.`,name:"do_center_crop"},{anchor:"transformers.TvltImageProcessor.preprocess.crop_size",description:`<strong>crop_size</strong> (<code>Dict[str, int]</code>, <em>optional</em>, defaults to <code>self.crop_size</code>) &#x2014;
Size of the image after applying the centre crop.`,name:"crop_size"},{anchor:"transformers.TvltImageProcessor.preprocess.do_rescale",description:`<strong>do_rescale</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>self.do_rescale</code>) &#x2014;
Whether to rescale the image values between [0 - 1].`,name:"do_rescale"},{anchor:"transformers.TvltImageProcessor.preprocess.rescale_factor",description:`<strong>rescale_factor</strong> (<code>float</code>, <em>optional</em>, defaults to <code>self.rescale_factor</code>) &#x2014;
Rescale factor to rescale the image by if <code>do_rescale</code> is set to <code>True</code>.`,name:"rescale_factor"},{anchor:"transformers.TvltImageProcessor.preprocess.do_normalize",description:`<strong>do_normalize</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>self.do_normalize</code>) &#x2014;
Whether to normalize the image.`,name:"do_normalize"},{anchor:"transformers.TvltImageProcessor.preprocess.image_mean",description:`<strong>image_mean</strong> (<code>float</code> or <code>List[float]</code>, <em>optional</em>, defaults to <code>self.image_mean</code>) &#x2014;
Image mean.`,name:"image_mean"},{anchor:"transformers.TvltImageProcessor.preprocess.image_std",description:`<strong>image_std</strong> (<code>float</code> or <code>List[float]</code>, <em>optional</em>, defaults to <code>self.image_std</code>) &#x2014;
Image standard deviation.`,name:"image_std"},{anchor:"transformers.TvltImageProcessor.preprocess.is_mixed",description:`<strong>is_mixed</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If the input video has negative samples.`,name:"is_mixed"},{anchor:"transformers.TvltImageProcessor.preprocess.return_tensors",description:`<strong>return_tensors</strong> (<code>str</code> or <code>TensorType</code>, <em>optional</em>) &#x2014;
The type of tensors to return. Can be one of:<ul>
<li>Unset: Return a list of <code>np.ndarray</code>.</li>
<li><code>TensorType.TENSORFLOW</code> or <code>&apos;tf&apos;</code>: Return a batch of type <code>tf.Tensor</code>.</li>
<li><code>TensorType.PYTORCH</code> or <code>&apos;pt&apos;</code>: Return a batch of type <code>torch.Tensor</code>.</li>
<li><code>TensorType.NUMPY</code> or <code>&apos;np&apos;</code>: Return a batch of type <code>np.ndarray</code>.</li>
<li><code>TensorType.JAX</code> or <code>&apos;jax&apos;</code>: Return a batch of type <code>jax.numpy.ndarray</code>.</li>
</ul>`,name:"return_tensors"},{anchor:"transformers.TvltImageProcessor.preprocess.data_format",description:`<strong>data_format</strong> (<code>ChannelDimension</code> or <code>str</code>, <em>optional</em>, defaults to <code>ChannelDimension.FIRST</code>) &#x2014;
The channel dimension format for the output image. Can be one of:<ul>
<li><code>ChannelDimension.FIRST</code>: image in (num_channels, height, width) format.</li>
<li><code>ChannelDimension.LAST</code>: image in (height, width, num_channels) format.</li>
<li>Unset: Use the inferred channel dimension format of the input image.</li>
</ul>`,name:"data_format"}],source:"https://github.com/huggingface/transformers/blob/vr_22367/src/transformers/models/tvlt/image_processing_tvlt.py#L306",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_22367/en/main_classes/image_processor#transformers.BatchFeature"
>BatchFeature</a> with the following fields:</p>
<ul>
<li>
<p><strong>pixel_values</strong> \u2014 Pixel values to be fed to a model, of shape (batch_size, num_channels, height,
width).</p>
</li>
<li>
<p><strong>pixel_mask</strong> \u2014 Pixel masks to be fed to a model, of shape (batch_size, num_pixel_patches).</p>
</li>
<li>
<p><strong>pixel_values_mixed</strong> \u2014 Pixel values with both postive or negative to be fed to a model, of shape
(batch_size, num_channels, height, width).</p>
</li>
<li>
<p><strong>pixel_mask_mixed</strong> \u2014 Pixel masks with both postive or negative to be fed to a model, of shape
(batch_size, num_pixel_patches).</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22367/en/main_classes/image_processor#transformers.BatchFeature"
>BatchFeature</a></p>
`}}),oo=new ne({}),to=new M({props:{name:"class transformers.TvltFeatureExtractor",anchor:"transformers.TvltFeatureExtractor",parameters:[{name:"spectrogram_length",val:" = 2048"},{name:"num_channels",val:" = 1"},{name:"patch_size",val:" = [16, 16]"},{name:"feature_size",val:" = 128"},{name:"sampling_rate",val:" = 44100"},{name:"hop_length_to_sampling_rate",val:" = 86"},{name:"n_fft",val:" = 2048"},{name:"padding_value",val:" = 0.0"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TvltFeatureExtractor.spectrogram_length",description:`<strong>spectrogram_length</strong> (<code>Dict[str, int]</code> <em>optional</em>, defaults to 2048) &#x2014;
The time length of each audio spectrogram.`,name:"spectrogram_length"},{anchor:"transformers.TvltFeatureExtractor.num_channels",description:`<strong>num_channels</strong> (<code>int</code> <em>optional</em>, defaults to 1) &#x2014;
Number of audio channels.`,name:"num_channels"},{anchor:"transformers.TvltFeatureExtractor.patch_size",description:`<strong>patch_size</strong> (<code>List[int]</code> <em>optional</em>, defaults to <code>[16, 16]</code>) &#x2014;
The patch size of audio patch embedding.`,name:"patch_size"},{anchor:"transformers.TvltFeatureExtractor.feature_size",description:`<strong>feature_size</strong> (<code>int</code>, defaults to 128) &#x2014;
The frequency length of audio spectrogram.`,name:"feature_size"},{anchor:"transformers.TvltFeatureExtractor.sampling_rate",description:`<strong>sampling_rate</strong> (<code>int</code>, defaults to 44100) &#x2014;
The sampling rate at which the audio files should be digitalized expressed in Hertz (Hz).`,name:"sampling_rate"},{anchor:"transformers.TvltFeatureExtractor.hop_length_to_sampling_rate",description:`<strong>hop_length_to_sampling_rate</strong> (<code>int</code>, defaults to 86) &#x2014;
Hop length is length of the overlaping windows for the STFT used to obtain the Mel Frequency coefficients.
For example, with sampling rate 44100, the hop length is 512, with 44100 / 512 = 86`,name:"hop_length_to_sampling_rate"},{anchor:"transformers.TvltFeatureExtractor.n_fft",description:`<strong>n_fft</strong> (<code>int</code>, defaults to 2048) &#x2014;
Size of the Fourier transform.`,name:"n_fft"},{anchor:"transformers.TvltFeatureExtractor.padding_value",description:`<strong>padding_value</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
Padding value used to pad the audio. Should correspond to silences.`,name:"padding_value"}],source:"https://github.com/huggingface/transformers/blob/vr_22367/src/transformers/models/tvlt/feature_extraction_tvlt.py#L30"}}),so=new M({props:{name:"__call__",anchor:"transformers.TvltFeatureExtractor.__call__",parameters:[{name:"raw_speech",val:": typing.Union[numpy.ndarray, typing.List[float], typing.List[numpy.ndarray], typing.List[typing.List[float]]]"},{name:"return_tensors",val:": typing.Union[str, transformers.utils.generic.TensorType, NoneType] = None"},{name:"return_attention_mask",val:": typing.Optional[bool] = True"},{name:"sampling_rate",val:": typing.Optional[int] = None"},{name:"resample",val:": bool = False"},{name:"mask_audio",val:": bool = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TvltFeatureExtractor.__call__.raw_speech",description:`<strong>raw_speech</strong> (<code>np.ndarray</code>, <code>List[float]</code>, <code>List[np.ndarray]</code>, <code>List[List[float]]</code>) &#x2014;
The sequence or batch of sequences to be padded. Each sequence can be a numpy array, a list of float
values, a list of numpy arrays or a list of list of float values.`,name:"raw_speech"},{anchor:"transformers.TvltFeatureExtractor.__call__.return_tensors",description:`<strong>return_tensors</strong> (<code>str</code> or <a href="/docs/transformers/pr_22367/en/internal/file_utils#transformers.TensorType">TensorType</a>, <em>optional</em>) &#x2014;
If set, will return tensors instead of list of python integers. Acceptable values are:</p>
<ul>
<li><code>&apos;pt&apos;</code>: Return PyTorch <code>torch.Tensor</code> objects.</li>
<li><code>&apos;np&apos;</code>: Return Numpy <code>np.ndarray</code> objects.</li>
</ul>`,name:"return_tensors"},{anchor:"transformers.TvltFeatureExtractor.__call__.return_attention_mask",description:`<strong>return_attention_mask</strong> (<code>bool</code>, <em>optional</em>, default to <code>True</code>) &#x2014;
Whether to return the attention mask. If left to the default, will return the attention mask according
to the specific feature_extractor&#x2019;s default. <a href="../glossary#attention-mask">What are attention masks?</a></p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						
<p>For TvltTransformer models, <code>attention_mask</code> should alwys be passed for batched inference, to avoid
subtle bugs.</p>

					</div>`,name:"return_attention_mask"},{anchor:"transformers.TvltFeatureExtractor.__call__.sampling_rate",description:`<strong>sampling_rate</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The sampling rate at which the <code>raw_speech</code> input was sampled. It is strongly recommended to pass
<code>sampling_rate</code> at the forward call to prevent silent errors and allow automatic speech recognition
pipeline. Current model supports sampling rate 16000 and 44100.`,name:"sampling_rate"},{anchor:"transformers.TvltFeatureExtractor.__call__.resample",description:`<strong>resample</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
If the sampling rate is not matched, resample the input audio to match.`,name:"resample"},{anchor:"transformers.TvltFeatureExtractor.__call__.mask_audio",description:`<strong>mask_audio</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to mask input audio for MAE task.`,name:"mask_audio"}],source:"https://github.com/huggingface/transformers/blob/vr_22367/src/transformers/models/tvlt/feature_extraction_tvlt.py#L225",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_22367/en/main_classes/image_processor#transformers.BatchFeature"
>BatchFeature</a> with the following fields:</p>
<ul>
<li>
<p><strong>audio_values</strong> \u2014 Audio values to be fed to a model, of shape (batch_size, num_channels, height,
width).</p>
</li>
<li>
<p><strong>audio_mask</strong> \u2014 Audio masks to be fed to a model, of shape (batch_size, num_audio_patches).</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22367/en/main_classes/image_processor#transformers.BatchFeature"
>BatchFeature</a></p>
`}}),ao=new ne({}),no=new M({props:{name:"class transformers.TvltModel",anchor:"transformers.TvltModel",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.TvltModel.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltConfig">TvltConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_22367/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_22367/src/transformers/models/tvlt/modeling_tvlt.py#L684"}}),co=new M({props:{name:"forward",anchor:"transformers.TvltModel.forward",parameters:[{name:"pixel_values",val:""},{name:"audio_values",val:""},{name:"pixel_mask",val:" = None"},{name:"audio_mask",val:" = None"},{name:"mask_pixel",val:" = False"},{name:"mask_audio",val:" = False"},{name:"output_attentions",val:" = None"},{name:"output_hidden_states",val:" = None"},{name:"return_dict",val:" = None"}],parametersDescription:[{anchor:"transformers.TvltModel.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_frames, num_channels, height, width)</code>) &#x2014;
Pixel values. Pixel values can be obtained using <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor">TvltProcessor</a>. See <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor.__call__">TvltProcessor.<strong>call</strong>()</a> for
details.`,name:"pixel_values"},{anchor:"transformers.TvltModel.forward.audio_values",description:`<strong>audio_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Audio values. Audio values can be obtained using <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor">TvltProcessor</a>. See <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor.__call__">TvltProcessor.<strong>call</strong>()</a> for
details.`,name:"audio_values"},{anchor:"transformers.TvltModel.forward.pixel_mask",description:`<strong>pixel_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_pixel_patches)</code>) &#x2014;
Pixel masks. Pixel masks can be obtained using <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor">TvltProcessor</a>. See <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor.__call__">TvltProcessor.<strong>call</strong>()</a> for
details.`,name:"pixel_mask"},{anchor:"transformers.TvltModel.forward.audio_mask",description:`<strong>audio_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_audio_patches)</code>) &#x2014;
Audio masks. Audio masks can be obtained using <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor">TvltProcessor</a>. See <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor.__call__">TvltProcessor.<strong>call</strong>()</a> for
details.`,name:"audio_mask"},{anchor:"transformers.TvltModel.forward.pixel_values_mixed",description:`<strong>pixel_values_mixed</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_frames, num_channels, height, width)</code>) &#x2014;
Pixel values that mix positive and negative samples in Tvlt vision-audio matching. Pixel values mixed can
be obtained using <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor">TvltProcessor</a>. See <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor.__call__">TvltProcessor.<strong>call</strong>()</a> for details.`,name:"pixel_values_mixed"},{anchor:"transformers.TvltModel.forward.pixel_mask_mixed",description:`<strong>pixel_mask_mixed</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel masks of pixel_values_mixed. Pixel masks mixed can be obtained using <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor">TvltProcessor</a>. See
<a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor.__call__">TvltProcessor.<strong>call</strong>()</a> for details.`,name:"pixel_mask_mixed"},{anchor:"transformers.TvltModel.forward.mask_pixel",description:`<strong>mask_pixel</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether to mask pixel for MAE tasks. Only set to True in TvltForPreTraining.`,name:"mask_pixel"},{anchor:"transformers.TvltModel.forward.mask_audio",description:`<strong>mask_audio</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether to mask audio for MAE tasks. Only set to True in TvltForPreTraining.`,name:"mask_audio"},{anchor:"transformers.TvltModel.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.TvltModel.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.TvltModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_22367/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/vr_22367/src/transformers/models/tvlt/modeling_tvlt.py#L714",returnDescription:`
<p>A <code>transformers.models.tvlt.modeling_tvlt.TvltModelOutput</code> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltConfig"
>TvltConfig</a>) and inputs.</p>
<ul>
<li><strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the model.</li>
<li><strong>last_pixel_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, pixel_sequence_length, hidden_size)</code>) \u2014 Pixel sequence of hidden-states at the output of the last layer of the model.</li>
<li><strong>last_audio_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, audio_sequence_length, hidden_size)</code>) \u2014 Audio sequence of hidden-states at the output of the last layer of the model.</li>
<li><strong>pixel_label_masks</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, pixel_patch_length)</code>) \u2014 Tensor indicating which pixel patches are masked (1) and which are not (0).</li>
<li><strong>audio_label_masks</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, audio_patch_length)</code>) \u2014 Tensor indicating which audio patches are masked (1) and which are not (0).</li>
<li><strong>pixel_ids_restore</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, pixel_patch_length)</code>) \u2014 Tensor containing the ids permutation of pixel masking.</li>
<li><strong>audio_ids_restore</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, audio_patch_length)</code>) \u2014 Tensor containing the ids permutation of audio masking.</li>
<li><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings and one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the model at the output of each layer
plus the initial embedding outputs.</li>
<li><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights after the attention softmax, used to compute the weighted average in
the self-attention heads.</li>
</ul>
`,returnType:`
<p><code>transformers.models.tvlt.modeling_tvlt.TvltModelOutput</code> or <code>tuple(torch.FloatTensor)</code></p>
`}}),Te=new mn({props:{$$slots:{default:[Ii]},$$scope:{ctx:k}}}),be=new Pr({props:{anchor:"transformers.TvltModel.forward.example",$$slots:{default:[Mi]},$$scope:{ctx:k}}}),mo=new ne({}),po=new M({props:{name:"class transformers.TvltForPreTraining",anchor:"transformers.TvltForPreTraining",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.TvltForPreTraining.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltConfig">TvltConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_22367/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_22367/src/transformers/models/tvlt/modeling_tvlt.py#L915"}}),uo=new M({props:{name:"forward",anchor:"transformers.TvltForPreTraining.forward",parameters:[{name:"pixel_values",val:""},{name:"audio_values",val:""},{name:"pixel_mask",val:" = None"},{name:"audio_mask",val:" = None"},{name:"labels",val:" = None"},{name:"pixel_values_mixed",val:" = None"},{name:"pixel_mask_mixed",val:" = None"},{name:"output_attentions",val:" = None"},{name:"output_hidden_states",val:" = None"},{name:"return_dict",val:" = None"}],parametersDescription:[{anchor:"transformers.TvltForPreTraining.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_frames, num_channels, height, width)</code>) &#x2014;
Pixel values. Pixel values can be obtained using <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor">TvltProcessor</a>. See <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor.__call__">TvltProcessor.<strong>call</strong>()</a> for
details.`,name:"pixel_values"},{anchor:"transformers.TvltForPreTraining.forward.audio_values",description:`<strong>audio_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Audio values. Audio values can be obtained using <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor">TvltProcessor</a>. See <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor.__call__">TvltProcessor.<strong>call</strong>()</a> for
details.`,name:"audio_values"},{anchor:"transformers.TvltForPreTraining.forward.pixel_mask",description:`<strong>pixel_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_pixel_patches)</code>) &#x2014;
Pixel masks. Pixel masks can be obtained using <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor">TvltProcessor</a>. See <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor.__call__">TvltProcessor.<strong>call</strong>()</a> for
details.`,name:"pixel_mask"},{anchor:"transformers.TvltForPreTraining.forward.audio_mask",description:`<strong>audio_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_audio_patches)</code>) &#x2014;
Audio masks. Audio masks can be obtained using <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor">TvltProcessor</a>. See <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor.__call__">TvltProcessor.<strong>call</strong>()</a> for
details.`,name:"audio_mask"},{anchor:"transformers.TvltForPreTraining.forward.pixel_values_mixed",description:`<strong>pixel_values_mixed</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_frames, num_channels, height, width)</code>) &#x2014;
Pixel values that mix positive and negative samples in Tvlt vision-audio matching. Pixel values mixed can
be obtained using <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor">TvltProcessor</a>. See <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor.__call__">TvltProcessor.<strong>call</strong>()</a> for details.`,name:"pixel_values_mixed"},{anchor:"transformers.TvltForPreTraining.forward.pixel_mask_mixed",description:`<strong>pixel_mask_mixed</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel masks of pixel_values_mixed. Pixel masks mixed can be obtained using <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor">TvltProcessor</a>. See
<a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor.__call__">TvltProcessor.<strong>call</strong>()</a> for details.`,name:"pixel_mask_mixed"},{anchor:"transformers.TvltForPreTraining.forward.mask_pixel",description:`<strong>mask_pixel</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether to mask pixel for MAE tasks. Only set to True in TvltForPreTraining.`,name:"mask_pixel"},{anchor:"transformers.TvltForPreTraining.forward.mask_audio",description:`<strong>mask_audio</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether to mask audio for MAE tasks. Only set to True in TvltForPreTraining.`,name:"mask_audio"},{anchor:"transformers.TvltForPreTraining.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.TvltForPreTraining.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.TvltForPreTraining.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_22367/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.TvltForPreTraining.forward.pixel_values_mixed",description:`<strong>pixel_values_mixed</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_frames, num_channels, height, width)</code>) &#x2014;
Pixel values that mix positive and negative samples in Tvlt vision-audio matching. Audio values can be
obtained using <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor">TvltProcessor</a>. See <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor.__call__">TvltProcessor.<strong>call</strong>()</a> for details.`,name:"pixel_values_mixed"},{anchor:"transformers.TvltForPreTraining.forward.pixel_mask_mixed",description:`<strong>pixel_mask_mixed</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel masks of pixel_values_mixed. Pixel values mixed can be obtained using <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor">TvltProcessor</a>. See
<a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor.__call__">TvltProcessor.<strong>call</strong>()</a> for details.`,name:"pixel_mask_mixed"},{anchor:"transformers.TvltForPreTraining.forward.labels",description:`<strong>labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, num_labels)</code>, <em>optional</em>) &#x2014;
Labels for computing the vision audio matching loss. Indices should be in <code>[0, 1]</code>. num_labels has to be 1.`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/vr_22367/src/transformers/models/tvlt/modeling_tvlt.py#L1048",returnDescription:`
<p>A <code>transformers.models.tvlt.modeling_tvlt.TvltForPreTrainingOutput</code> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltConfig"
>TvltConfig</a>) and inputs.</p>
<ul>
<li><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>) \u2014 Pixel reconstruction loss.</li>
<li><strong>matching_logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, 1)</code>) \u2014 Matching objective logits.</li>
<li><strong>pixel_logits</strong> (<code>torch.FloatTensor</code> of shape
<code>(batch_size, pixel_patch_length, image_patch_size ** 3 * pixel_num_channels)</code>): Pixel reconstruction
logits.</li>
<li><strong>audio_logits</strong> (<code>torch.FloatTensor</code> of shape
<code>(batch_size, audio_patch_length, image_patch_size[0] * image_patch_size[1])</code>): Audio reconstruction
logits.</li>
<li><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings and one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the model at the output of each layer
plus the initial embedding outputs.</li>
<li><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights after the attention softmax, used to compute the weighted average in
the self-attention heads.</li>
</ul>
`,returnType:`
<p><code>transformers.models.tvlt.modeling_tvlt.TvltForPreTrainingOutput</code> or <code>tuple(torch.FloatTensor)</code></p>
`}}),we=new mn({props:{$$slots:{default:[ji]},$$scope:{ctx:k}}}),Pe=new Pr({props:{anchor:"transformers.TvltForPreTraining.forward.example",$$slots:{default:[Vi]},$$scope:{ctx:k}}}),go=new ne({}),_o=new M({props:{name:"class transformers.TvltForAudioVisualClassification",anchor:"transformers.TvltForAudioVisualClassification",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.TvltForAudioVisualClassification.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltConfig">TvltConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_22367/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_22367/src/transformers/models/tvlt/modeling_tvlt.py#L1231"}}),bo=new M({props:{name:"forward",anchor:"transformers.TvltForAudioVisualClassification.forward",parameters:[{name:"pixel_values",val:""},{name:"audio_values",val:""},{name:"pixel_mask",val:" = None"},{name:"audio_mask",val:" = None"},{name:"output_attentions",val:" = None"},{name:"output_hidden_states",val:" = None"},{name:"return_dict",val:" = None"},{name:"labels",val:" = None"}],parametersDescription:[{anchor:"transformers.TvltForAudioVisualClassification.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_frames, num_channels, height, width)</code>) &#x2014;
Pixel values. Pixel values can be obtained using <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor">TvltProcessor</a>. See <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor.__call__">TvltProcessor.<strong>call</strong>()</a> for
details.`,name:"pixel_values"},{anchor:"transformers.TvltForAudioVisualClassification.forward.audio_values",description:`<strong>audio_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Audio values. Audio values can be obtained using <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor">TvltProcessor</a>. See <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor.__call__">TvltProcessor.<strong>call</strong>()</a> for
details.`,name:"audio_values"},{anchor:"transformers.TvltForAudioVisualClassification.forward.pixel_mask",description:`<strong>pixel_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_pixel_patches)</code>) &#x2014;
Pixel masks. Pixel masks can be obtained using <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor">TvltProcessor</a>. See <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor.__call__">TvltProcessor.<strong>call</strong>()</a> for
details.`,name:"pixel_mask"},{anchor:"transformers.TvltForAudioVisualClassification.forward.audio_mask",description:`<strong>audio_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_audio_patches)</code>) &#x2014;
Audio masks. Audio masks can be obtained using <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor">TvltProcessor</a>. See <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor.__call__">TvltProcessor.<strong>call</strong>()</a> for
details.`,name:"audio_mask"},{anchor:"transformers.TvltForAudioVisualClassification.forward.pixel_values_mixed",description:`<strong>pixel_values_mixed</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_frames, num_channels, height, width)</code>) &#x2014;
Pixel values that mix positive and negative samples in Tvlt vision-audio matching. Pixel values mixed can
be obtained using <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor">TvltProcessor</a>. See <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor.__call__">TvltProcessor.<strong>call</strong>()</a> for details.`,name:"pixel_values_mixed"},{anchor:"transformers.TvltForAudioVisualClassification.forward.pixel_mask_mixed",description:`<strong>pixel_mask_mixed</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel masks of pixel_values_mixed. Pixel masks mixed can be obtained using <a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor">TvltProcessor</a>. See
<a href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor.__call__">TvltProcessor.<strong>call</strong>()</a> for details.`,name:"pixel_mask_mixed"},{anchor:"transformers.TvltForAudioVisualClassification.forward.mask_pixel",description:`<strong>mask_pixel</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether to mask pixel for MAE tasks. Only set to True in TvltForPreTraining.`,name:"mask_pixel"},{anchor:"transformers.TvltForAudioVisualClassification.forward.mask_audio",description:`<strong>mask_audio</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether to mask audio for MAE tasks. Only set to True in TvltForPreTraining.`,name:"mask_audio"},{anchor:"transformers.TvltForAudioVisualClassification.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.TvltForAudioVisualClassification.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.TvltForAudioVisualClassification.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_22367/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.TvltForAudioVisualClassification.forward.labels",description:`<strong>labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, num_labels)</code>, <em>optional</em>) &#x2014;
Labels for computing the audiovisual loss. Indices should be in <code>[0, ..., num_classes-1]</code> where num_classes
refers to the number of classes in audiovisual tasks.`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/vr_22367/src/transformers/models/tvlt/modeling_tvlt.py#L1249",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_22367/en/main_classes/output#transformers.modeling_outputs.SequenceClassifierOutput"
>transformers.modeling_outputs.SequenceClassifierOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltConfig"
>TvltConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Classification (or regression if config.num_labels==1) loss.</p>
</li>
<li>
<p><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, config.num_labels)</code>) \u2014 Classification (or regression if config.num_labels==1) scores (before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22367/en/main_classes/output#transformers.modeling_outputs.SequenceClassifierOutput"
>transformers.modeling_outputs.SequenceClassifierOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),ye=new mn({props:{$$slots:{default:[qi]},$$scope:{ctx:k}}}),ke=new Pr({props:{anchor:"transformers.TvltForAudioVisualClassification.forward.example",$$slots:{default:[Si]},$$scope:{ctx:k}}}),{c(){h=r("meta"),y=c(),_=r("h1"),u=r("a"),v=r("span"),T(l.$$.fragment),g=c(),E=r("span"),kr=n("TVLT"),Vt=c(),Z=r("h2"),ie=r("a"),Jo=r("span"),T(qe.$$.fragment),Er=c(),Yo=r("span"),Fr=n("Overview"),qt=c(),le=r("p"),zr=n("The TVLT model was proposed in "),Se=r("a"),Cr=n("TVLT: Textless Vision-Language Transformer"),Ar=n(`
by Zineng Tang, Jaemin Cho, Yixin Nie, Mohit Bansal (the first three authors contributed equally). The Textless Vision-Language Transformer (TVLT) is a model that uses raw visual and audio inputs for vision-and-language representation learning, without using text-specific modules such as tokenization or automatic speech recognition (ASR). It can perform various audiovisual and vision-language tasks like retrieval, question answering, etc.`),St=c(),Po=r("p"),Lr=n("The abstract from the paper is the following:"),Nt=c(),$o=r("p"),Xo=r("em"),Ir=n("In this work, we present the Textless Vision-Language Transformer (TVLT), where homogeneous transformer blocks take raw visual and audio inputs for vision-and-language representation learning with minimal modality-specific design, and do not use text-specific modules such as tokenization or automatic speech recognition (ASR). TVLT is trained by reconstructing masked patches of continuous video frames and audio spectrograms (masked autoencoding) and contrastive modeling to align video and audio. TVLT attains performance comparable to its text-based counterpart on various multimodal tasks, such as visual question answering, image retrieval, video retrieval, and multimodal sentiment analysis, with 28x faster inference speed and only 1/3 of the parameters. Our findings suggest the possibility of learning compact and efficient visual-linguistic representations from low-level visual and audio signals without assuming the prior existence of text."),Dt=c(),yo=r("p"),Mr=n("Tips:"),Ot=c(),j=r("ul"),D=r("li"),jr=n("TVLT is a model that takes both "),Ko=r("code"),Vr=n("pixel_values"),qr=n(" and "),Qo=r("code"),Sr=n("audio_values"),Nr=n(" as input. One can use "),ko=r("a"),Dr=n("TvltProcessor"),Or=n(` to prepare data for the model.
This processor wraps an image processor (for the image/video modality) and an audio feature extractor (for the audio modality) into one.`),Rr=c(),H=r("li"),Wr=n("TVLT is trained with images/videos and audios of various sizes: the authors resize and crop the input images/videos to 224 and limit the length of audio spectrogram to 2048. To make batching of videos and audios possible, the authors use a "),et=r("code"),Ur=n("pixel_mask"),Zr=n(" that indicates which pixels are real/padding and "),ot=r("code"),Hr=n("audio_mask"),Br=n(" that indicates which audio values are real/padding."),Gr=c(),Ne=r("li"),Jr=n("The design of TVLT is very similar to that of a standard Vision Transformer (ViT) and masked autoencoder (MAE) as in "),Eo=r("a"),Yr=n("ViTMAE"),Xr=n(". The difference is that the model includes embedding layers for the audio modality."),Kr=c(),tt=r("li"),Qr=n("The PyTorch version of this model is only available in torch 1.10 and higher."),Rt=c(),De=r("p"),Oe=r("img"),Wt=c(),de=r("small"),es=n("TVLT architecture. Taken from the "),Fo=r("a"),os=n("original paper"),ts=n("."),Ut=c(),W=r("p"),rs=n("The original code can be found "),Re=r("a"),ss=n("here"),as=n(". This model was contributed by "),We=r("a"),ns=n("Zineng Tang"),is=n("."),Zt=c(),B=r("h2"),ce=r("a"),rt=r("span"),T(Ue.$$.fragment),ls=c(),st=r("span"),ds=n("TvltConfig"),Ht=c(),F=r("div"),T(Ze.$$.fragment),cs=c(),G=r("p"),ms=n("This is the configuration class to store the configuration of a "),zo=r("a"),ps=n("TvltModel"),hs=n(`. It is used to instantiate a TVLT
model according to the specified arguments, defining the model architecture. Instantiating a configuration with the
defaults will yield a similar configuration to that of the TVLT
`),He=r("a"),fs=n("ZinengTang/tvlt-base"),us=n(" architecture."),gs=c(),J=r("p"),_s=n("Configuration objects inherit from "),Co=r("a"),vs=n("PretrainedConfig"),Ts=n(` and can be used to control the model outputs. Read the
documentation from `),Ao=r("a"),bs=n("PretrainedConfig"),xs=n(" for more information."),ws=c(),T(me.$$.fragment),Bt=c(),Y=r("h2"),pe=r("a"),at=r("span"),T(Be.$$.fragment),Ps=c(),nt=r("span"),$s=n("TvltProcessor"),Gt=c(),z=r("div"),T(Ge.$$.fragment),ys=c(),it=r("p"),ks=n("Constructs a TVLT processor which wraps a TVLT image processor and TVLT feature extractor into a single processor."),Es=c(),V=r("p"),Lo=r("a"),Fs=n("TvltProcessor"),zs=n(" offers all the functionalities of "),Io=r("a"),Cs=n("TvltImageProcessor"),As=n(" and "),Mo=r("a"),Ls=n("TvltFeatureExtractor"),Is=n(`. See the
docstring of `),Je=r("a"),lt=r("strong"),Ms=n("call"),js=n("()"),Vs=n(" for more information."),qs=c(),he=r("div"),T(Ye.$$.fragment),Ss=c(),C=r("p"),Ns=n("Forwards the "),dt=r("code"),Ds=n("images"),Os=n(" argument to TvltImageProcessor\u2019s "),jo=r("a"),Rs=n("preprocess()"),Ws=n(" and the "),ct=r("code"),Us=n("audio"),Zs=n(`
argument to TvltFeatureExtractor\u2019s `),Xe=r("a"),mt=r("strong"),Hs=n("call"),Bs=n("()"),Gs=n(`. Please refer to the docstring of the
above two methods for more information.`),Jt=c(),X=r("h2"),fe=r("a"),pt=r("span"),T(Ke.$$.fragment),Js=c(),ht=r("span"),Ys=n("TvltImageProcessor"),Yt=c(),A=r("div"),T(Qe.$$.fragment),Xs=c(),ft=r("p"),Ks=n("Constructs a TVLT image processor."),Qs=c(),ut=r("p"),ea=n("This processor can be used to prepare either videos or images for the model by converting images to 1-frame videos."),oa=c(),ue=r("div"),T(eo.$$.fragment),ta=c(),gt=r("p"),ra=n("Preprocess an videos or image or batch of videos or images."),Xt=c(),K=r("h2"),ge=r("a"),_t=r("span"),T(oo.$$.fragment),sa=c(),vt=r("span"),aa=n("TvltFeatureExtractor"),Kt=c(),L=r("div"),T(to.$$.fragment),na=c(),Tt=r("p"),ia=n("Constructs a TVLT audio feature extractor. This feature extractor can be used to prepare audios for the model."),la=c(),ro=r("p"),da=n("This feature extractor inherits from "),Vo=r("a"),ca=n("FeatureExtractionMixin"),ma=n(` which contains most of the main methods. Users
should refer to this superclass for more information regarding those methods.`),pa=c(),_e=r("div"),T(so.$$.fragment),ha=c(),bt=r("p"),fa=n("Main method to prepare one or several audio(s) for the model."),Qt=c(),Q=r("h2"),ve=r("a"),xt=r("span"),T(ao.$$.fragment),ua=c(),wt=r("span"),ga=n("TvltModel"),er=c(),O=r("div"),T(no.$$.fragment),_a=c(),io=r("p"),va=n(`The bare TVLT Model transformer outputting raw hidden-states without any specific head on top.
This model is a PyTorch `),lo=r("a"),Ta=n("torch.nn.Module"),ba=n(` subclass. Use it
as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),xa=c(),q=r("div"),T(co.$$.fragment),wa=c(),ee=r("p"),Pa=n("The "),qo=r("a"),$a=n("TvltModel"),ya=n(" forward method, overrides the "),Pt=r("code"),ka=n("__call__"),Ea=n(" special method."),Fa=c(),T(Te.$$.fragment),za=c(),T(be.$$.fragment),or=c(),oe=r("h2"),xe=r("a"),$t=r("span"),T(mo.$$.fragment),Ca=c(),yt=r("span"),Aa=n("TvltForPreTraining"),tr=c(),R=r("div"),T(po.$$.fragment),La=c(),ho=r("p"),Ia=n(`The TVLT Model transformer with the decoder on top for self-supervised pre-training.
This model is a PyTorch `),fo=r("a"),Ma=n("torch.nn.Module"),ja=n(` subclass. Use it
as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Va=c(),S=r("div"),T(uo.$$.fragment),qa=c(),te=r("p"),Sa=n("The "),So=r("a"),Na=n("TvltForPreTraining"),Da=n(" forward method, overrides the "),kt=r("code"),Oa=n("__call__"),Ra=n(" special method."),Wa=c(),T(we.$$.fragment),Ua=c(),T(Pe.$$.fragment),rr=c(),re=r("h2"),$e=r("a"),Et=r("span"),T(go.$$.fragment),Za=c(),Ft=r("span"),Ha=n("TvltForAudioVisualClassification"),sr=c(),I=r("div"),T(_o.$$.fragment),Ba=c(),zt=r("p"),Ga=n(`Tvlt Model transformer with a classifier head on top (an MLP on top of the final hidden state of the [CLS] token)
for audiovisual classification tasks, e.g. CMU-MOSEI Sentiment Analysis and Audio to Video Retrieval.`),Ja=c(),vo=r("p"),Ya=n("This model is a PyTorch "),To=r("a"),Xa=n("torch.nn.Module"),Ka=n(` subclass. Use it
as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Qa=c(),N=r("div"),T(bo.$$.fragment),en=c(),se=r("p"),on=n("The "),No=r("a"),tn=n("TvltForAudioVisualClassification"),rn=n(" forward method, overrides the "),Ct=r("code"),sn=n("__call__"),an=n(" special method."),nn=c(),T(ye.$$.fragment),ln=c(),T(ke.$$.fragment),this.h()},l(o){const p=zi('[data-svelte="svelte-1phssyn"]',document.head);h=s(p,"META",{name:!0,content:!0}),p.forEach(t),y=m(o),_=s(o,"H1",{class:!0});var xo=a(_);u=s(xo,"A",{id:!0,class:!0,href:!0});var At=a(u);v=s(At,"SPAN",{});var Lt=a(v);b(l.$$.fragment,Lt),Lt.forEach(t),At.forEach(t),g=m(xo),E=s(xo,"SPAN",{});var It=a(E);kr=i(It,"TVLT"),It.forEach(t),xo.forEach(t),Vt=m(o),Z=s(o,"H2",{class:!0});var wo=a(Z);ie=s(wo,"A",{id:!0,class:!0,href:!0});var Mt=a(ie);Jo=s(Mt,"SPAN",{});var jt=a(Jo);b(qe.$$.fragment,jt),jt.forEach(t),Mt.forEach(t),Er=m(wo),Yo=s(wo,"SPAN",{});var hn=a(Yo);Fr=i(hn,"Overview"),hn.forEach(t),wo.forEach(t),qt=m(o),le=s(o,"P",{});var nr=a(le);zr=i(nr,"The TVLT model was proposed in "),Se=s(nr,"A",{href:!0,rel:!0});var fn=a(Se);Cr=i(fn,"TVLT: Textless Vision-Language Transformer"),fn.forEach(t),Ar=i(nr,`
by Zineng Tang, Jaemin Cho, Yixin Nie, Mohit Bansal (the first three authors contributed equally). The Textless Vision-Language Transformer (TVLT) is a model that uses raw visual and audio inputs for vision-and-language representation learning, without using text-specific modules such as tokenization or automatic speech recognition (ASR). It can perform various audiovisual and vision-language tasks like retrieval, question answering, etc.`),nr.forEach(t),St=m(o),Po=s(o,"P",{});var un=a(Po);Lr=i(un,"The abstract from the paper is the following:"),un.forEach(t),Nt=m(o),$o=s(o,"P",{});var gn=a($o);Xo=s(gn,"EM",{});var _n=a(Xo);Ir=i(_n,"In this work, we present the Textless Vision-Language Transformer (TVLT), where homogeneous transformer blocks take raw visual and audio inputs for vision-and-language representation learning with minimal modality-specific design, and do not use text-specific modules such as tokenization or automatic speech recognition (ASR). TVLT is trained by reconstructing masked patches of continuous video frames and audio spectrograms (masked autoencoding) and contrastive modeling to align video and audio. TVLT attains performance comparable to its text-based counterpart on various multimodal tasks, such as visual question answering, image retrieval, video retrieval, and multimodal sentiment analysis, with 28x faster inference speed and only 1/3 of the parameters. Our findings suggest the possibility of learning compact and efficient visual-linguistic representations from low-level visual and audio signals without assuming the prior existence of text."),_n.forEach(t),gn.forEach(t),Dt=m(o),yo=s(o,"P",{});var vn=a(yo);Mr=i(vn,"Tips:"),vn.forEach(t),Ot=m(o),j=s(o,"UL",{});var Ee=a(j);D=s(Ee,"LI",{});var Fe=a(D);jr=i(Fe,"TVLT is a model that takes both "),Ko=s(Fe,"CODE",{});var Tn=a(Ko);Vr=i(Tn,"pixel_values"),Tn.forEach(t),qr=i(Fe," and "),Qo=s(Fe,"CODE",{});var bn=a(Qo);Sr=i(bn,"audio_values"),bn.forEach(t),Nr=i(Fe," as input. One can use "),ko=s(Fe,"A",{href:!0});var xn=a(ko);Dr=i(xn,"TvltProcessor"),xn.forEach(t),Or=i(Fe,` to prepare data for the model.
This processor wraps an image processor (for the image/video modality) and an audio feature extractor (for the audio modality) into one.`),Fe.forEach(t),Rr=m(Ee),H=s(Ee,"LI",{});var Do=a(H);Wr=i(Do,"TVLT is trained with images/videos and audios of various sizes: the authors resize and crop the input images/videos to 224 and limit the length of audio spectrogram to 2048. To make batching of videos and audios possible, the authors use a "),et=s(Do,"CODE",{});var wn=a(et);Ur=i(wn,"pixel_mask"),wn.forEach(t),Zr=i(Do," that indicates which pixels are real/padding and "),ot=s(Do,"CODE",{});var Pn=a(ot);Hr=i(Pn,"audio_mask"),Pn.forEach(t),Br=i(Do," that indicates which audio values are real/padding."),Do.forEach(t),Gr=m(Ee),Ne=s(Ee,"LI",{});var ir=a(Ne);Jr=i(ir,"The design of TVLT is very similar to that of a standard Vision Transformer (ViT) and masked autoencoder (MAE) as in "),Eo=s(ir,"A",{href:!0});var $n=a(Eo);Yr=i($n,"ViTMAE"),$n.forEach(t),Xr=i(ir,". The difference is that the model includes embedding layers for the audio modality."),ir.forEach(t),Kr=m(Ee),tt=s(Ee,"LI",{});var yn=a(tt);Qr=i(yn,"The PyTorch version of this model is only available in torch 1.10 and higher."),yn.forEach(t),Ee.forEach(t),Rt=m(o),De=s(o,"P",{align:!0});var kn=a(De);Oe=s(kn,"IMG",{src:!0,alt:!0,width:!0}),kn.forEach(t),Wt=m(o),de=s(o,"SMALL",{});var lr=a(de);es=i(lr,"TVLT architecture. Taken from the "),Fo=s(lr,"A",{href:!0});var En=a(Fo);os=i(En,"original paper"),En.forEach(t),ts=i(lr,"."),lr.forEach(t),Ut=m(o),W=s(o,"P",{});var Oo=a(W);rs=i(Oo,"The original code can be found "),Re=s(Oo,"A",{href:!0,rel:!0});var Fn=a(Re);ss=i(Fn,"here"),Fn.forEach(t),as=i(Oo,". This model was contributed by "),We=s(Oo,"A",{href:!0,rel:!0});var zn=a(We);ns=i(zn,"Zineng Tang"),zn.forEach(t),is=i(Oo,"."),Oo.forEach(t),Zt=m(o),B=s(o,"H2",{class:!0});var dr=a(B);ce=s(dr,"A",{id:!0,class:!0,href:!0});var Cn=a(ce);rt=s(Cn,"SPAN",{});var An=a(rt);b(Ue.$$.fragment,An),An.forEach(t),Cn.forEach(t),ls=m(dr),st=s(dr,"SPAN",{});var Ln=a(st);ds=i(Ln,"TvltConfig"),Ln.forEach(t),dr.forEach(t),Ht=m(o),F=s(o,"DIV",{class:!0});var ze=a(F);b(Ze.$$.fragment,ze),cs=m(ze),G=s(ze,"P",{});var Ro=a(G);ms=i(Ro,"This is the configuration class to store the configuration of a "),zo=s(Ro,"A",{href:!0});var In=a(zo);ps=i(In,"TvltModel"),In.forEach(t),hs=i(Ro,`. It is used to instantiate a TVLT
model according to the specified arguments, defining the model architecture. Instantiating a configuration with the
defaults will yield a similar configuration to that of the TVLT
`),He=s(Ro,"A",{href:!0,rel:!0});var Mn=a(He);fs=i(Mn,"ZinengTang/tvlt-base"),Mn.forEach(t),us=i(Ro," architecture."),Ro.forEach(t),gs=m(ze),J=s(ze,"P",{});var Wo=a(J);_s=i(Wo,"Configuration objects inherit from "),Co=s(Wo,"A",{href:!0});var jn=a(Co);vs=i(jn,"PretrainedConfig"),jn.forEach(t),Ts=i(Wo,` and can be used to control the model outputs. Read the
documentation from `),Ao=s(Wo,"A",{href:!0});var Vn=a(Ao);bs=i(Vn,"PretrainedConfig"),Vn.forEach(t),xs=i(Wo," for more information."),Wo.forEach(t),ws=m(ze),b(me.$$.fragment,ze),ze.forEach(t),Bt=m(o),Y=s(o,"H2",{class:!0});var cr=a(Y);pe=s(cr,"A",{id:!0,class:!0,href:!0});var qn=a(pe);at=s(qn,"SPAN",{});var Sn=a(at);b(Be.$$.fragment,Sn),Sn.forEach(t),qn.forEach(t),Ps=m(cr),nt=s(cr,"SPAN",{});var Nn=a(nt);$s=i(Nn,"TvltProcessor"),Nn.forEach(t),cr.forEach(t),Gt=m(o),z=s(o,"DIV",{class:!0});var Ce=a(z);b(Ge.$$.fragment,Ce),ys=m(Ce),it=s(Ce,"P",{});var Dn=a(it);ks=i(Dn,"Constructs a TVLT processor which wraps a TVLT image processor and TVLT feature extractor into a single processor."),Dn.forEach(t),Es=m(Ce),V=s(Ce,"P",{});var ae=a(V);Lo=s(ae,"A",{href:!0});var On=a(Lo);Fs=i(On,"TvltProcessor"),On.forEach(t),zs=i(ae," offers all the functionalities of "),Io=s(ae,"A",{href:!0});var Rn=a(Io);Cs=i(Rn,"TvltImageProcessor"),Rn.forEach(t),As=i(ae," and "),Mo=s(ae,"A",{href:!0});var Wn=a(Mo);Ls=i(Wn,"TvltFeatureExtractor"),Wn.forEach(t),Is=i(ae,`. See the
docstring of `),Je=s(ae,"A",{href:!0});var dn=a(Je);lt=s(dn,"STRONG",{});var Un=a(lt);Ms=i(Un,"call"),Un.forEach(t),js=i(dn,"()"),dn.forEach(t),Vs=i(ae," for more information."),ae.forEach(t),qs=m(Ce),he=s(Ce,"DIV",{class:!0});var mr=a(he);b(Ye.$$.fragment,mr),Ss=m(mr),C=s(mr,"P",{});var U=a(C);Ns=i(U,"Forwards the "),dt=s(U,"CODE",{});var Zn=a(dt);Ds=i(Zn,"images"),Zn.forEach(t),Os=i(U," argument to TvltImageProcessor\u2019s "),jo=s(U,"A",{href:!0});var Hn=a(jo);Rs=i(Hn,"preprocess()"),Hn.forEach(t),Ws=i(U," and the "),ct=s(U,"CODE",{});var Bn=a(ct);Us=i(Bn,"audio"),Bn.forEach(t),Zs=i(U,`
argument to TvltFeatureExtractor\u2019s `),Xe=s(U,"A",{href:!0});var cn=a(Xe);mt=s(cn,"STRONG",{});var Gn=a(mt);Hs=i(Gn,"call"),Gn.forEach(t),Bs=i(cn,"()"),cn.forEach(t),Gs=i(U,`. Please refer to the docstring of the
above two methods for more information.`),U.forEach(t),mr.forEach(t),Ce.forEach(t),Jt=m(o),X=s(o,"H2",{class:!0});var pr=a(X);fe=s(pr,"A",{id:!0,class:!0,href:!0});var Jn=a(fe);pt=s(Jn,"SPAN",{});var Yn=a(pt);b(Ke.$$.fragment,Yn),Yn.forEach(t),Jn.forEach(t),Js=m(pr),ht=s(pr,"SPAN",{});var Xn=a(ht);Ys=i(Xn,"TvltImageProcessor"),Xn.forEach(t),pr.forEach(t),Yt=m(o),A=s(o,"DIV",{class:!0});var Ae=a(A);b(Qe.$$.fragment,Ae),Xs=m(Ae),ft=s(Ae,"P",{});var Kn=a(ft);Ks=i(Kn,"Constructs a TVLT image processor."),Kn.forEach(t),Qs=m(Ae),ut=s(Ae,"P",{});var Qn=a(ut);ea=i(Qn,"This processor can be used to prepare either videos or images for the model by converting images to 1-frame videos."),Qn.forEach(t),oa=m(Ae),ue=s(Ae,"DIV",{class:!0});var hr=a(ue);b(eo.$$.fragment,hr),ta=m(hr),gt=s(hr,"P",{});var ei=a(gt);ra=i(ei,"Preprocess an videos or image or batch of videos or images."),ei.forEach(t),hr.forEach(t),Ae.forEach(t),Xt=m(o),K=s(o,"H2",{class:!0});var fr=a(K);ge=s(fr,"A",{id:!0,class:!0,href:!0});var oi=a(ge);_t=s(oi,"SPAN",{});var ti=a(_t);b(oo.$$.fragment,ti),ti.forEach(t),oi.forEach(t),sa=m(fr),vt=s(fr,"SPAN",{});var ri=a(vt);aa=i(ri,"TvltFeatureExtractor"),ri.forEach(t),fr.forEach(t),Kt=m(o),L=s(o,"DIV",{class:!0});var Le=a(L);b(to.$$.fragment,Le),na=m(Le),Tt=s(Le,"P",{});var si=a(Tt);ia=i(si,"Constructs a TVLT audio feature extractor. This feature extractor can be used to prepare audios for the model."),si.forEach(t),la=m(Le),ro=s(Le,"P",{});var ur=a(ro);da=i(ur,"This feature extractor inherits from "),Vo=s(ur,"A",{href:!0});var ai=a(Vo);ca=i(ai,"FeatureExtractionMixin"),ai.forEach(t),ma=i(ur,` which contains most of the main methods. Users
should refer to this superclass for more information regarding those methods.`),ur.forEach(t),pa=m(Le),_e=s(Le,"DIV",{class:!0});var gr=a(_e);b(so.$$.fragment,gr),ha=m(gr),bt=s(gr,"P",{});var ni=a(bt);fa=i(ni,"Main method to prepare one or several audio(s) for the model."),ni.forEach(t),gr.forEach(t),Le.forEach(t),Qt=m(o),Q=s(o,"H2",{class:!0});var _r=a(Q);ve=s(_r,"A",{id:!0,class:!0,href:!0});var ii=a(ve);xt=s(ii,"SPAN",{});var li=a(xt);b(ao.$$.fragment,li),li.forEach(t),ii.forEach(t),ua=m(_r),wt=s(_r,"SPAN",{});var di=a(wt);ga=i(di,"TvltModel"),di.forEach(t),_r.forEach(t),er=m(o),O=s(o,"DIV",{class:!0});var Uo=a(O);b(no.$$.fragment,Uo),_a=m(Uo),io=s(Uo,"P",{});var vr=a(io);va=i(vr,`The bare TVLT Model transformer outputting raw hidden-states without any specific head on top.
This model is a PyTorch `),lo=s(vr,"A",{href:!0,rel:!0});var ci=a(lo);Ta=i(ci,"torch.nn.Module"),ci.forEach(t),ba=i(vr,` subclass. Use it
as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),vr.forEach(t),xa=m(Uo),q=s(Uo,"DIV",{class:!0});var Ie=a(q);b(co.$$.fragment,Ie),wa=m(Ie),ee=s(Ie,"P",{});var Zo=a(ee);Pa=i(Zo,"The "),qo=s(Zo,"A",{href:!0});var mi=a(qo);$a=i(mi,"TvltModel"),mi.forEach(t),ya=i(Zo," forward method, overrides the "),Pt=s(Zo,"CODE",{});var pi=a(Pt);ka=i(pi,"__call__"),pi.forEach(t),Ea=i(Zo," special method."),Zo.forEach(t),Fa=m(Ie),b(Te.$$.fragment,Ie),za=m(Ie),b(be.$$.fragment,Ie),Ie.forEach(t),Uo.forEach(t),or=m(o),oe=s(o,"H2",{class:!0});var Tr=a(oe);xe=s(Tr,"A",{id:!0,class:!0,href:!0});var hi=a(xe);$t=s(hi,"SPAN",{});var fi=a($t);b(mo.$$.fragment,fi),fi.forEach(t),hi.forEach(t),Ca=m(Tr),yt=s(Tr,"SPAN",{});var ui=a(yt);Aa=i(ui,"TvltForPreTraining"),ui.forEach(t),Tr.forEach(t),tr=m(o),R=s(o,"DIV",{class:!0});var Ho=a(R);b(po.$$.fragment,Ho),La=m(Ho),ho=s(Ho,"P",{});var br=a(ho);Ia=i(br,`The TVLT Model transformer with the decoder on top for self-supervised pre-training.
This model is a PyTorch `),fo=s(br,"A",{href:!0,rel:!0});var gi=a(fo);Ma=i(gi,"torch.nn.Module"),gi.forEach(t),ja=i(br,` subclass. Use it
as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),br.forEach(t),Va=m(Ho),S=s(Ho,"DIV",{class:!0});var Me=a(S);b(uo.$$.fragment,Me),qa=m(Me),te=s(Me,"P",{});var Bo=a(te);Sa=i(Bo,"The "),So=s(Bo,"A",{href:!0});var _i=a(So);Na=i(_i,"TvltForPreTraining"),_i.forEach(t),Da=i(Bo," forward method, overrides the "),kt=s(Bo,"CODE",{});var vi=a(kt);Oa=i(vi,"__call__"),vi.forEach(t),Ra=i(Bo," special method."),Bo.forEach(t),Wa=m(Me),b(we.$$.fragment,Me),Ua=m(Me),b(Pe.$$.fragment,Me),Me.forEach(t),Ho.forEach(t),rr=m(o),re=s(o,"H2",{class:!0});var xr=a(re);$e=s(xr,"A",{id:!0,class:!0,href:!0});var Ti=a($e);Et=s(Ti,"SPAN",{});var bi=a(Et);b(go.$$.fragment,bi),bi.forEach(t),Ti.forEach(t),Za=m(xr),Ft=s(xr,"SPAN",{});var xi=a(Ft);Ha=i(xi,"TvltForAudioVisualClassification"),xi.forEach(t),xr.forEach(t),sr=m(o),I=s(o,"DIV",{class:!0});var je=a(I);b(_o.$$.fragment,je),Ba=m(je),zt=s(je,"P",{});var wi=a(zt);Ga=i(wi,`Tvlt Model transformer with a classifier head on top (an MLP on top of the final hidden state of the [CLS] token)
for audiovisual classification tasks, e.g. CMU-MOSEI Sentiment Analysis and Audio to Video Retrieval.`),wi.forEach(t),Ja=m(je),vo=s(je,"P",{});var wr=a(vo);Ya=i(wr,"This model is a PyTorch "),To=s(wr,"A",{href:!0,rel:!0});var Pi=a(To);Xa=i(Pi,"torch.nn.Module"),Pi.forEach(t),Ka=i(wr,` subclass. Use it
as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),wr.forEach(t),Qa=m(je),N=s(je,"DIV",{class:!0});var Ve=a(N);b(bo.$$.fragment,Ve),en=m(Ve),se=s(Ve,"P",{});var Go=a(se);on=i(Go,"The "),No=s(Go,"A",{href:!0});var $i=a(No);tn=i($i,"TvltForAudioVisualClassification"),$i.forEach(t),rn=i(Go," forward method, overrides the "),Ct=s(Go,"CODE",{});var yi=a(Ct);sn=i(yi,"__call__"),yi.forEach(t),an=i(Go," special method."),Go.forEach(t),nn=m(Ve),b(ye.$$.fragment,Ve),ln=m(Ve),b(ke.$$.fragment,Ve),Ve.forEach(t),je.forEach(t),this.h()},h(){d(h,"name","hf:doc:metadata"),d(h,"content",JSON.stringify(Di)),d(u,"id","tvlt"),d(u,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(u,"href","#tvlt"),d(_,"class","relative group"),d(ie,"id","overview"),d(ie,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(ie,"href","#overview"),d(Z,"class","relative group"),d(Se,"href","https://arxiv.org/abs/2209.14156"),d(Se,"rel","nofollow"),d(ko,"href","/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor"),d(Eo,"href","vitmae"),Ci(Oe.src,pn="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/transformers/model_doc/tvlt_architecture.png")||d(Oe,"src",pn),d(Oe,"alt","drawing"),d(Oe,"width","600"),d(De,"align","center"),d(Fo,"href","[https://arxiv.org/abs/2102.03334](https://arxiv.org/abs/2209.14156)"),d(Re,"href","https://github.com/zinengtang/TVLT"),d(Re,"rel","nofollow"),d(We,"href","https://huggingface.co/ZinengTang"),d(We,"rel","nofollow"),d(ce,"id","transformers.TvltConfig"),d(ce,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(ce,"href","#transformers.TvltConfig"),d(B,"class","relative group"),d(zo,"href","/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltModel"),d(He,"href","https://huggingface.co/ZinengTang/tvlt-base"),d(He,"rel","nofollow"),d(Co,"href","/docs/transformers/pr_22367/en/main_classes/configuration#transformers.PretrainedConfig"),d(Ao,"href","/docs/transformers/pr_22367/en/main_classes/configuration#transformers.PretrainedConfig"),d(F,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(pe,"id","transformers.TvltProcessor"),d(pe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(pe,"href","#transformers.TvltProcessor"),d(Y,"class","relative group"),d(Lo,"href","/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor"),d(Io,"href","/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltImageProcessor"),d(Mo,"href","/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltFeatureExtractor"),d(Je,"href","/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltProcessor.__call__"),d(jo,"href","/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltImageProcessor.preprocess"),d(Xe,"href","/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltFeatureExtractor.__call__"),d(he,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(fe,"id","transformers.TvltImageProcessor"),d(fe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(fe,"href","#transformers.TvltImageProcessor"),d(X,"class","relative group"),d(ue,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(A,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ge,"id","transformers.TvltFeatureExtractor"),d(ge,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(ge,"href","#transformers.TvltFeatureExtractor"),d(K,"class","relative group"),d(Vo,"href","/docs/transformers/pr_22367/en/main_classes/feature_extractor#transformers.FeatureExtractionMixin"),d(_e,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(L,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ve,"id","transformers.TvltModel"),d(ve,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(ve,"href","#transformers.TvltModel"),d(Q,"class","relative group"),d(lo,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),d(lo,"rel","nofollow"),d(qo,"href","/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltModel"),d(q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(O,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(xe,"id","transformers.TvltForPreTraining"),d(xe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(xe,"href","#transformers.TvltForPreTraining"),d(oe,"class","relative group"),d(fo,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),d(fo,"rel","nofollow"),d(So,"href","/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltForPreTraining"),d(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(R,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d($e,"id","transformers.TvltForAudioVisualClassification"),d($e,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d($e,"href","#transformers.TvltForAudioVisualClassification"),d(re,"class","relative group"),d(To,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),d(To,"rel","nofollow"),d(No,"href","/docs/transformers/pr_22367/en/model_doc/tvlt#transformers.TvltForAudioVisualClassification"),d(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(I,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(o,p){e(document.head,h),f(o,y,p),f(o,_,p),e(_,u),e(u,v),x(l,v,null),e(_,g),e(_,E),e(E,kr),f(o,Vt,p),f(o,Z,p),e(Z,ie),e(ie,Jo),x(qe,Jo,null),e(Z,Er),e(Z,Yo),e(Yo,Fr),f(o,qt,p),f(o,le,p),e(le,zr),e(le,Se),e(Se,Cr),e(le,Ar),f(o,St,p),f(o,Po,p),e(Po,Lr),f(o,Nt,p),f(o,$o,p),e($o,Xo),e(Xo,Ir),f(o,Dt,p),f(o,yo,p),e(yo,Mr),f(o,Ot,p),f(o,j,p),e(j,D),e(D,jr),e(D,Ko),e(Ko,Vr),e(D,qr),e(D,Qo),e(Qo,Sr),e(D,Nr),e(D,ko),e(ko,Dr),e(D,Or),e(j,Rr),e(j,H),e(H,Wr),e(H,et),e(et,Ur),e(H,Zr),e(H,ot),e(ot,Hr),e(H,Br),e(j,Gr),e(j,Ne),e(Ne,Jr),e(Ne,Eo),e(Eo,Yr),e(Ne,Xr),e(j,Kr),e(j,tt),e(tt,Qr),f(o,Rt,p),f(o,De,p),e(De,Oe),f(o,Wt,p),f(o,de,p),e(de,es),e(de,Fo),e(Fo,os),e(de,ts),f(o,Ut,p),f(o,W,p),e(W,rs),e(W,Re),e(Re,ss),e(W,as),e(W,We),e(We,ns),e(W,is),f(o,Zt,p),f(o,B,p),e(B,ce),e(ce,rt),x(Ue,rt,null),e(B,ls),e(B,st),e(st,ds),f(o,Ht,p),f(o,F,p),x(Ze,F,null),e(F,cs),e(F,G),e(G,ms),e(G,zo),e(zo,ps),e(G,hs),e(G,He),e(He,fs),e(G,us),e(F,gs),e(F,J),e(J,_s),e(J,Co),e(Co,vs),e(J,Ts),e(J,Ao),e(Ao,bs),e(J,xs),e(F,ws),x(me,F,null),f(o,Bt,p),f(o,Y,p),e(Y,pe),e(pe,at),x(Be,at,null),e(Y,Ps),e(Y,nt),e(nt,$s),f(o,Gt,p),f(o,z,p),x(Ge,z,null),e(z,ys),e(z,it),e(it,ks),e(z,Es),e(z,V),e(V,Lo),e(Lo,Fs),e(V,zs),e(V,Io),e(Io,Cs),e(V,As),e(V,Mo),e(Mo,Ls),e(V,Is),e(V,Je),e(Je,lt),e(lt,Ms),e(Je,js),e(V,Vs),e(z,qs),e(z,he),x(Ye,he,null),e(he,Ss),e(he,C),e(C,Ns),e(C,dt),e(dt,Ds),e(C,Os),e(C,jo),e(jo,Rs),e(C,Ws),e(C,ct),e(ct,Us),e(C,Zs),e(C,Xe),e(Xe,mt),e(mt,Hs),e(Xe,Bs),e(C,Gs),f(o,Jt,p),f(o,X,p),e(X,fe),e(fe,pt),x(Ke,pt,null),e(X,Js),e(X,ht),e(ht,Ys),f(o,Yt,p),f(o,A,p),x(Qe,A,null),e(A,Xs),e(A,ft),e(ft,Ks),e(A,Qs),e(A,ut),e(ut,ea),e(A,oa),e(A,ue),x(eo,ue,null),e(ue,ta),e(ue,gt),e(gt,ra),f(o,Xt,p),f(o,K,p),e(K,ge),e(ge,_t),x(oo,_t,null),e(K,sa),e(K,vt),e(vt,aa),f(o,Kt,p),f(o,L,p),x(to,L,null),e(L,na),e(L,Tt),e(Tt,ia),e(L,la),e(L,ro),e(ro,da),e(ro,Vo),e(Vo,ca),e(ro,ma),e(L,pa),e(L,_e),x(so,_e,null),e(_e,ha),e(_e,bt),e(bt,fa),f(o,Qt,p),f(o,Q,p),e(Q,ve),e(ve,xt),x(ao,xt,null),e(Q,ua),e(Q,wt),e(wt,ga),f(o,er,p),f(o,O,p),x(no,O,null),e(O,_a),e(O,io),e(io,va),e(io,lo),e(lo,Ta),e(io,ba),e(O,xa),e(O,q),x(co,q,null),e(q,wa),e(q,ee),e(ee,Pa),e(ee,qo),e(qo,$a),e(ee,ya),e(ee,Pt),e(Pt,ka),e(ee,Ea),e(q,Fa),x(Te,q,null),e(q,za),x(be,q,null),f(o,or,p),f(o,oe,p),e(oe,xe),e(xe,$t),x(mo,$t,null),e(oe,Ca),e(oe,yt),e(yt,Aa),f(o,tr,p),f(o,R,p),x(po,R,null),e(R,La),e(R,ho),e(ho,Ia),e(ho,fo),e(fo,Ma),e(ho,ja),e(R,Va),e(R,S),x(uo,S,null),e(S,qa),e(S,te),e(te,Sa),e(te,So),e(So,Na),e(te,Da),e(te,kt),e(kt,Oa),e(te,Ra),e(S,Wa),x(we,S,null),e(S,Ua),x(Pe,S,null),f(o,rr,p),f(o,re,p),e(re,$e),e($e,Et),x(go,Et,null),e(re,Za),e(re,Ft),e(Ft,Ha),f(o,sr,p),f(o,I,p),x(_o,I,null),e(I,Ba),e(I,zt),e(zt,Ga),e(I,Ja),e(I,vo),e(vo,Ya),e(vo,To),e(To,Xa),e(vo,Ka),e(I,Qa),e(I,N),x(bo,N,null),e(N,en),e(N,se),e(se,on),e(se,No),e(No,tn),e(se,rn),e(se,Ct),e(Ct,sn),e(se,an),e(N,nn),x(ye,N,null),e(N,ln),x(ke,N,null),ar=!0},p(o,[p]){const xo={};p&2&&(xo.$$scope={dirty:p,ctx:o}),me.$set(xo);const At={};p&2&&(At.$$scope={dirty:p,ctx:o}),Te.$set(At);const Lt={};p&2&&(Lt.$$scope={dirty:p,ctx:o}),be.$set(Lt);const It={};p&2&&(It.$$scope={dirty:p,ctx:o}),we.$set(It);const wo={};p&2&&(wo.$$scope={dirty:p,ctx:o}),Pe.$set(wo);const Mt={};p&2&&(Mt.$$scope={dirty:p,ctx:o}),ye.$set(Mt);const jt={};p&2&&(jt.$$scope={dirty:p,ctx:o}),ke.$set(jt)},i(o){ar||(w(l.$$.fragment,o),w(qe.$$.fragment,o),w(Ue.$$.fragment,o),w(Ze.$$.fragment,o),w(me.$$.fragment,o),w(Be.$$.fragment,o),w(Ge.$$.fragment,o),w(Ye.$$.fragment,o),w(Ke.$$.fragment,o),w(Qe.$$.fragment,o),w(eo.$$.fragment,o),w(oo.$$.fragment,o),w(to.$$.fragment,o),w(so.$$.fragment,o),w(ao.$$.fragment,o),w(no.$$.fragment,o),w(co.$$.fragment,o),w(Te.$$.fragment,o),w(be.$$.fragment,o),w(mo.$$.fragment,o),w(po.$$.fragment,o),w(uo.$$.fragment,o),w(we.$$.fragment,o),w(Pe.$$.fragment,o),w(go.$$.fragment,o),w(_o.$$.fragment,o),w(bo.$$.fragment,o),w(ye.$$.fragment,o),w(ke.$$.fragment,o),ar=!0)},o(o){P(l.$$.fragment,o),P(qe.$$.fragment,o),P(Ue.$$.fragment,o),P(Ze.$$.fragment,o),P(me.$$.fragment,o),P(Be.$$.fragment,o),P(Ge.$$.fragment,o),P(Ye.$$.fragment,o),P(Ke.$$.fragment,o),P(Qe.$$.fragment,o),P(eo.$$.fragment,o),P(oo.$$.fragment,o),P(to.$$.fragment,o),P(so.$$.fragment,o),P(ao.$$.fragment,o),P(no.$$.fragment,o),P(co.$$.fragment,o),P(Te.$$.fragment,o),P(be.$$.fragment,o),P(mo.$$.fragment,o),P(po.$$.fragment,o),P(uo.$$.fragment,o),P(we.$$.fragment,o),P(Pe.$$.fragment,o),P(go.$$.fragment,o),P(_o.$$.fragment,o),P(bo.$$.fragment,o),P(ye.$$.fragment,o),P(ke.$$.fragment,o),ar=!1},d(o){t(h),o&&t(y),o&&t(_),$(l),o&&t(Vt),o&&t(Z),$(qe),o&&t(qt),o&&t(le),o&&t(St),o&&t(Po),o&&t(Nt),o&&t($o),o&&t(Dt),o&&t(yo),o&&t(Ot),o&&t(j),o&&t(Rt),o&&t(De),o&&t(Wt),o&&t(de),o&&t(Ut),o&&t(W),o&&t(Zt),o&&t(B),$(Ue),o&&t(Ht),o&&t(F),$(Ze),$(me),o&&t(Bt),o&&t(Y),$(Be),o&&t(Gt),o&&t(z),$(Ge),$(Ye),o&&t(Jt),o&&t(X),$(Ke),o&&t(Yt),o&&t(A),$(Qe),$(eo),o&&t(Xt),o&&t(K),$(oo),o&&t(Kt),o&&t(L),$(to),$(so),o&&t(Qt),o&&t(Q),$(ao),o&&t(er),o&&t(O),$(no),$(co),$(Te),$(be),o&&t(or),o&&t(oe),$(mo),o&&t(tr),o&&t(R),$(po),$(uo),$(we),$(Pe),o&&t(rr),o&&t(re),$(go),o&&t(sr),o&&t(I),$(_o),$(bo),$(ye),$(ke)}}}const Di={local:"tvlt",sections:[{local:"overview",title:"Overview"},{local:"transformers.TvltConfig",title:"TvltConfig"},{local:"transformers.TvltProcessor",title:"TvltProcessor"},{local:"transformers.TvltImageProcessor",title:"TvltImageProcessor"},{local:"transformers.TvltFeatureExtractor",title:"TvltFeatureExtractor"},{local:"transformers.TvltModel",title:"TvltModel"},{local:"transformers.TvltForPreTraining",title:"TvltForPreTraining"},{local:"transformers.TvltForAudioVisualClassification",title:"TvltForAudioVisualClassification"}],title:"TVLT"};function Oi(k){return Ai(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Gi extends ki{constructor(h){super();Ei(this,h,Oi,Ni,Fi,{})}}export{Gi as default,Di as metadata};
